##
## Como é a vida do estatístico
## (uma ilustração)
##
n <- 50
th <- seq(0.05, 0.95, l=101)
sX <- seq(0, n, l=51)
Mf <- Vectorize(function(theta, y, log=F) dbinom(y, prob=theta, size=n, log=log))
res <- outer(th, sX, Mf)
lres <- outer(th, sX, Mf, log=T)
contour(res)
#contour(lres)
persp(th, sX, res, th=140)

require(rgl)
open3d()
bg3d("lightgray")
persp3d(th, sX, res, aspect=c(1,1,0.75), col="lightblue")

##
open3d()
persp3d(th, sX, lres, aspect=c(1,1,0.5), col="lightgreen")
play3d(spin3d(axis=c(0,0,1), rpm=8), duration=10)
##

par(mfrow=c(1,3), mar=c(3,3,0.3,0.3), mgp=c(1.7, 0.8, 0))
th0.3 <- drop(outer(0.3, sX, Mf))
plot(th0.3, type="h")

sX30 <- drop(outer(th, 30, Mf))
plot(sX30, type="l")

sX30l <- drop(outer(th, 30, Mf, log=T))
plot(sX30l, type="l")

##
## Poisson
##
n <- 10
th <- seq(0.4, 5, l=101)
sX <- seq(0, 50, l=51)
Mf <- Vectorize(function(theta, y, log=F) 
					-n*theta + sum(y) * log(theta))
res <- outer(th, sX, Mf)
lres <- outer(th, sX, Mf, log=T)
contour(res)
#contour(lres)
persp(th, sX, res, theta=35, phi=5)

persp3d(th, sX, res, aspect=c(1,1,0.75), col="lightblue")
play3d(spin3d(axis=c(0,0,1), rpm=8), duration=15)

persp3d(th, sX, lres, aspect=c(1,1,0.75), col="lightblue")
play3d(spin3d(axis=c(0,0,1), rpm=8), duration=15)

